=== modified file '__init__.py'
--- __init__.py	2006-05-30 17:20:21 +0000
+++ __init__.py	2006-06-05 13:46:17 +0000
@@ -119,20 +119,41 @@
         raise CommandError("Unknown shelf subcommand '%s'" % cmd_name)
 
     def help(self):
-        lines = ["%s\n\nSubcommands:" % self.__doc__]
+        text = ["%s\n\nSubcommands:\n" % self.__doc__]
 
-        sub_help = []
-        maxlen = 0
         for cmd_class in self.subcommands:
-            usage = command_usage(cmd_class())
-            usage = usage.replace('bzr shelf-', '')
-            sub_help.append((usage, cmd_class.__doc__))
-            maxlen = max(maxlen, len(usage))
-
-        for usage, doc in sub_help:
-            lines.append("  %-*s  %s" % (maxlen, usage, doc))
-
-        return '\n'.join(lines)
+            text.extend(self.sub_help(cmd_class) + ['\n'])
+
+        return ''.join(text)
+
+    def sub_help(self, cmd_class):
+        text = []
+        cmd_obj = cmd_class()
+        indent = 2 * ' '
+
+        usage = command_usage(cmd_obj)
+        usage = usage.replace('bzr shelf-', '')
+        text.append('%s%s\n' % (indent, usage))
+
+        text.append('%s%s\n' % (2 * indent, cmd_class.__doc__))
+
+        # Somewhat copied from bzrlib.help.help_on_command_options
+        option_help = []
+        for option_name, option in sorted(cmd_obj.options().items()):
+            if option_name == 'help':
+                continue
+            option_help.append('%s--%s' % (3 * indent, option_name))
+            if option.type is not None:
+                option_help.append(' %s' % option.argname.upper())
+            if option.short_name():
+                option_help.append(', -%s' % option.short_name())
+            option_help.append('%s%s\n' % (2 * indent, option.help))
+
+        if len(option_help) > 0:
+            text.append('%soptions:\n' % (2 * indent))
+            text.extend(option_help)
+
+        return text
 
 
 class cmd_unshelve(bzrlib.commands.Command):

